{DelphiSim by Roeland van der Spek           }
{spekw@acm.org                               }
{(C) 1997                                    }
{v.2.00                                      }
{Generator Component                         }

unit generator;

interface
uses classes,Delphisim,random;

Type
      TGeneratorProcess = class;

      TFOnGenerate = procedure (Generator:TGeneratorProcess) of object;

      TGeneratorProcess = class(TSimProcess)
      private
        FOnGenerate :TFOnGenerate;
        dist:TDistribution;
        amount:Longint;
      protected
        Procedure body; override;
      published
        Property OnGenerate:TFOnGenerate read fongenerate write fongenerate;
        property Interval:TDistribution read Dist write dist;
        property NumberOfCycles:Longint read amount write amount;
      end;

procedure register;

implementation

procedure TGeneratorProcess.body;
var i:Longint;
begin
  if assigned(interval) and assigned(FOngenerate) then
  begin
    if amount >0 then
    begin
      I:=0;
      while I<amount do
      begin
        FOnGenerate(Self);
        holdfor(Interval.draw);
        i:=i+1;
      end;
    end
    else
    begin
      while not false do
      begin
        FOnGenerate(self);
        HoldFor(interval.draw);
      end;
    end;
  end;
end;

Procedure register;
begin
  registercomponents('delphisim',[TGeneratorProcess]);
end;

end.
